Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.jasig.portal.serialize
Class HTMLSerializer

    java.lang.Object
      org.jasig.portal.serialize.BaseMarkupSerializer
          org.jasig.portal.serialize.HTMLSerializer

All Implemented Interfaces:
  IAnchoringSerializer, DOMSerializer, Serializer, org.xml.sax.ContentHandler, org.xml.sax.DocumentHandler, org.xml.sax.DTDHandler, org.xml.sax.ext.DeclHandler, org.xml.sax.ext.LexicalHandler

Direct Known Subclasses:
  CachingHTMLSerializer

    public class HTMLSerializer

extends BaseMarkupSerializer
implements IAnchoringSerializer

Implements an HTML/XHTML serializer supporting both DOM and SAX pretty serializing. HTML/XHTML mode is determined in the constructor. For usage instructions see `Serializer`.

If an output stream is used, the encoding is taken from the output format (defaults to `UTF-8`). If a writer is used, make sure the writer uses the same encoding (if applies) as specified in the output format.

The serializer supports both DOM and SAX. DOM serializing is done by calling `BaseMarkupSerializer.serialize(Element)` and SAX serializing is done by firing SAX events and using the serializer as a document handler.

If an I/O exception occurs while serializing, the serializer will not throw an exception directly, but only throw it at the end of serializing (either DOM or SAX's `DocumentHandler.endDocument()`.

For elements that are not specified as whitespace preserving, the serializer will potentially break long text lines at space boundaries, indent lines, and serialize elements on separate lines. Line terminators will be regarded as spaces, and spaces at beginning of line will be stripped.

XHTML is slightly different than HTML:

- Element/attribute names are lower case and case matters
- Attributes must specify value, even if empty string
- Empty elements must have '/' in empty tag
- Contents of SCRIPT and STYLE elements serialized as CDATA

Version:
  $Revision: 1.10 $ $Date: 2005/04/20 20:03:06 $
Author:
  Assaf Arkin
See Also:
  `Serializer`

Field Summary
`private static boolean` | `_xhtml` True if serializing in XHTML format.
`private java.lang.String` | `anchorId`
`static java.lang.String` | `XHTMLNamespace`

Fields inherited from class org.jasig.portal.serialize.BaseMarkupSerializer
`_docTypePublicId, _docTypeSystemId, _format, _indenting, _prefixes, _printer, _started`

Constructor Summary
`` | `HTMLSerializer()` Constructs a new serializer.
`protected` | `HTMLSerializer(boolean xhtml, OutputFormat format)` Constructs a new HTML/XHTML serializer depending on the value of `xhtml`.
`` | `HTMLSerializer(OutputFormat format)` Constructs a new serializer.
`` | `HTMLSerializer(java.io.OutputStream output, OutputFormat format)` Constructs a new serializer that writes to the specified output stream using the specified output format.
`` | `HTMLSerializer(java.io.Writer writer, OutputFormat format)` Constructs a new serializer that writes to the specified writer using the specified output format.

Method Summary
`protected java.lang.String` | `appendAnchorIfNecessary(java.lang.String elementName, java.lang.String attributeName, java.lang.String attributeValue)`
`void` | `characters(char[] chars, int start, int length)`
`protected void` | `characters(java.lang.String text)` Called to print the text contents in the prevailing element format.
`void` | `endElement(java.lang.String tagName)`
`void` | `endElement(java.lang.String namespaceURI, java.lang.String localName, java.lang.String rawName)`
`void` | `endElementIO(java.lang.String namespaceURI, java.lang.String localName, java.lang.String rawName)`
`protected java.lang.String` | `escapeURI(java.lang.String uri)`
`protected java.lang.String` | `getEntityRef(int ch)` Returns the suitable entity reference for this character value, or null if no such entity exists.
`protected void` | `serializeElement(org.w3c.dom.Element elem)` Called to serialize a DOM element.
`void` | `setOutputFormat(OutputFormat format)` Specifies an output format for this serializer.
`void` | `startAnchoring(java.lang.String anchorId)` Signify that the serializer should begin to append the anchor ID to URLs of its choosing.
`protected void` | `startDocument(java.lang.String rootTagName)` Called to serialize the document's DOCTYPE by the root element.
`void` | `startElement(java.lang.String tagName, org.xml.sax.AttributeList attrs)`
`void` | `startElement(java.lang.String namespaceURI, java.lang.String localName, java.lang.String rawName, org.xml.sax.Attributes attrs)`
`void` | `stopAnchoring()` Signify that anchoring is no longer desired by the serializer.

Methods inherited from class org.jasig.portal.serialize.BaseMarkupSerializer
`asContentHandler, asDocumentHandler, asDOMSerializer, attributeDecl, comment, comment, content, elementDecl, endCDATA, endDocument, endDTD, endEntity, endNonEscaping, endPrefixMapping, endPreserving, enterElementState, externalEntityDecl, getElementState, getPrefix, ignorableWhitespace, internalEntityDecl, isDocumentState, leaveElementState, notationDecl, prepare, printDoctypeURL, printEscaped, printEscaped, printText, printText, processingInstruction, processingInstructionIO, reset, serialize, serialize, serialize, serializeNode, serializePreRoot, setDocumentLocator, setOutputByteStream, setOutputCharStream, skippedEntity, startCDATA, startDocument, startDTD, startEntity, startNonEscaping, startPrefixMapping, startPreserving, unparsedEntityDecl`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### _xhtml

    private static boolean _xhtml

  True if serializing in XHTML format.

### XHTMLNamespace

    public static java.lang.String XHTMLNamespace

### anchorId

    private java.lang.String anchorId

Constructor Detail

### HTMLSerializer

    protected HTMLSerializer(boolean xhtml,
                             OutputFormat format)

  Constructs a new HTML/XHTML serializer depending on the value of `xhtml`. The serializer cannot be used without calling init() first.

  Parameters:
    `xhtml` - True if XHTML serializing

### HTMLSerializer

    public HTMLSerializer()

  Constructs a new serializer. The serializer cannot be used without calling `BaseMarkupSerializer.setOutputCharStream(Writer)` or `BaseMarkupSerializer.setOutputByteStream(OutputStream)` first.

### HTMLSerializer

    public HTMLSerializer(OutputFormat format)

  Constructs a new serializer. The serializer cannot be used without calling `BaseMarkupSerializer.setOutputCharStream(Writer)` or `BaseMarkupSerializer.setOutputByteStream(OutputStream)` first.

### HTMLSerializer

    public HTMLSerializer(java.io.Writer writer,
                          OutputFormat format)

  Constructs a new serializer that writes to the specified writer using the specified output format. If `format` is null, will use a default output format.

  Parameters:
    `writer` - The writer to use
    `format` - The output format to use, null for the default

### HTMLSerializer

    public HTMLSerializer(java.io.OutputStream output,
                          OutputFormat format)

  Constructs a new serializer that writes to the specified output stream using the specified output format. If `format` is null, will use a default output format.

  Parameters:
    `output` - The output stream to use
    `format` - The output format to use, null for the default

Method Detail

### setOutputFormat

    public void setOutputFormat(OutputFormat format)

  Description copied from interface: `Serializer`
  Specifies an output format for this serializer. It the serializer has already been associated with an output format, it will switch to the new format. This method should not be called while the serializer is in the process of serializing a document.

  Specified by:
    `setOutputFormat` in interface `Serializer`
  Overrides:
    `setOutputFormat` in class `BaseMarkupSerializer`
  Parameters:
    `format` - The output format to use

### startElement

    public void startElement(java.lang.String namespaceURI,
                             java.lang.String localName,
                             java.lang.String rawName,
                             org.xml.sax.Attributes attrs)
                      throws org.xml.sax.SAXException

  Specified by:
    `startElement` in interface `org.xml.sax.ContentHandler`
  Throws:
    `org.xml.sax.SAXException`

### endElement

    public void endElement(java.lang.String namespaceURI,
                           java.lang.String localName,
                           java.lang.String rawName)
                    throws org.xml.sax.SAXException

  Specified by:
    `endElement` in interface `org.xml.sax.ContentHandler`
  Throws:
    `org.xml.sax.SAXException`

### endElementIO

    public void endElementIO(java.lang.String namespaceURI,
                             java.lang.String localName,
                             java.lang.String rawName)
                      throws java.io.IOException

  Throws:
    `java.io.IOException`

### characters

    public void characters(char[] chars,
                           int start,
                           int length)
                    throws org.xml.sax.SAXException

  Specified by:
    `characters` in interface `org.xml.sax.ContentHandler`
  Specified by:
    `characters` in interface `org.xml.sax.DocumentHandler`
  Overrides:
    `characters` in class `BaseMarkupSerializer`
  Throws:
    `org.xml.sax.SAXException`

### startElement

    public void startElement(java.lang.String tagName,
                             org.xml.sax.AttributeList attrs)
                      throws org.xml.sax.SAXException

  Specified by:
    `startElement` in interface `org.xml.sax.DocumentHandler`
  Throws:
    `org.xml.sax.SAXException`

### endElement

    public void endElement(java.lang.String tagName)
                    throws org.xml.sax.SAXException

  Specified by:
    `endElement` in interface `org.xml.sax.DocumentHandler`
  Throws:
    `org.xml.sax.SAXException`

### startDocument

    protected void startDocument(java.lang.String rootTagName)
                          throws java.io.IOException

  Called to serialize the document's DOCTYPE by the root element. The document type declaration must name the root element, but the root element is only known when that element is serialized, and not at the start of the document.

  This method will check if it has not been called before (`BaseMarkupSerializer._started`), will serialize the document type declaration, and will serialize all pre-root comments and PIs that were accumulated in the document (see `BaseMarkupSerializer.serializePreRoot()`). Pre-root will be serialized even if this is not the first root element of the document.

  Throws:
    `java.io.IOException`

### serializeElement

    protected void serializeElement(org.w3c.dom.Element elem)
                             throws java.io.IOException

  Called to serialize a DOM element. Equivalent to calling `startElement(String, String, String, Attributes)`, `endElement(String, String, String)` and serializing everything inbetween, but better optimized.

  Specified by:
    `serializeElement` in class `BaseMarkupSerializer`
  Parameters:
    `elem` - The element to serialize
  Throws:
    `java.io.IOException` - An I/O exception occured while serializing

### characters

    protected void characters(java.lang.String text)
                       throws java.io.IOException

  Description copied from class: `BaseMarkupSerializer`
  Called to print the text contents in the prevailing element format. Since this method is capable of printing text as CDATA, it is used for that purpose as well. White space handling is determined by the current element state. In addition, the output format can dictate whether the text is printed as CDATA or unescaped.

  Overrides:
    `characters` in class `BaseMarkupSerializer`
  Parameters:
    `text` - The text to print
  Throws:
    `java.io.IOException` - An I/O exception occured while serializing

### getEntityRef

    protected java.lang.String getEntityRef(int ch)

  Description copied from class: `BaseMarkupSerializer`
  Returns the suitable entity reference for this character value, or null if no such entity exists. Calling this method with `'&'` will return `"&amp;"`.

  Specified by:
    `getEntityRef` in class `BaseMarkupSerializer`
  Parameters:
    `ch` - Character value
  Returns:
    Character entity name, or null

### escapeURI

    protected java.lang.String escapeURI(java.lang.String uri)

### startAnchoring

    public void startAnchoring(java.lang.String anchorId)

  Description copied from interface: `IAnchoringSerializer`
  Signify that the serializer should begin to append the anchor ID to URLs of its choosing.

  Specified by:
    `startAnchoring` in interface `IAnchoringSerializer`
  Overrides:
    `startAnchoring` in class `BaseMarkupSerializer`
  Parameters:
    `anchorId` - the anchor identifier

### stopAnchoring

    public void stopAnchoring()

  Description copied from interface: `IAnchoringSerializer`
  Signify that anchoring is no longer desired by the serializer.

  Specified by:
    `stopAnchoring` in interface `IAnchoringSerializer`
  Overrides:
    `stopAnchoring` in class `BaseMarkupSerializer`

### appendAnchorIfNecessary

    protected java.lang.String appendAnchorIfNecessary(java.lang.String elementName,
                                                       java.lang.String attributeName,
                                                       java.lang.String attributeValue)

  Overrides:
    `appendAnchorIfNecessary` in class `BaseMarkupSerializer`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD